#!/usr/bin/python
# coding=UTF-8

# Багрепорты и фичареквесты можно слать сюда: faceless.nagato@gmail.com

import urllib
import json
import sys
import time
import re
import pynotify
import gtk.gdk
import optparse
import os
import subprocess

# DEFAULT OPTIONS
defaultBoard = 'lor'
defaultThread = '16218'
defaultTimeout = 30 # период проверки обновлений
defaultShowTime = 5000 # время отображения уведомления
defaultPostColor = '#65B2FF'
defaultQuoteColor = '#FFF11F'
defaultSpoilerColor = '#C8C8C8'
defaultCodeColor = '#E26AFF'
defaultHtmlFormat = True
defaultMaximumRating = 'sfw'
sad = True # sad, but true
#hideSage = True # sage disabled on dobrochan
# DEFAULT OPTIONS END

'''
"текст" - сообщение, содержащее текст не будет показано
"$exp regexp" - сообщение, содержащее регулярное выражение не будет показано
"$rep regexp replacement" - все найденные строки, подходящие под регулярные выражение regexp будут заменены на replacement
"$exec regexp command" - для каждой найденной строки будет выполнена команда command

Правила применяются в порядке очередности, поэтому
если сообщение отфильтровалось, то последующие правила
к нему не будут применены

http://docs.python.org/howto/regex.html
'''
# TODO: брать из файла
userRules = [
#    u"ололо",
#    r"$exp быдл[оау]",
#    r"$name User",
#    r"$rep ху[йяюе] 3,14",
#    r"$exec http://(www\.)?youtube(\.[a-z]+){1,3}/watch\?v=([A-Za-z0-9_-]+) bash -c 'cd /tmp && youtube-dl --no-progress -w \1 -o /tmp/\4 && ffmpeg -i /tmp/\4 -acodec libmp3lame /tmp/\4.mp3 && rm /tmp/\4 2>/dev/null && deadbeef --queue /tmp/\4.mp3 &'"
]

def userFilter(post):
    text = post['message']
    name = post['name']
    for rule in userRules:
        if rule.startswith("$exp "):
            try:
                r = re.compile(rule[5:len(rule)])
                if r.search(text,re.LOCALE|re.IGNORECASE):
                    return (False,"")
            except:
                sys.stderr.write(u"Ошибка при разборе регулярного выражения: %s\n"%rule)
                continue
        elif rule.startswith("$name "):
            if name == rule[6:len(rule)]:
                return (False,"")
        elif rule.startswith("$rep "):
            rule = rule[5:len(rule)]
            try:
                first = rule[0:rule.index(" ")]
                second = rule[rule.index(" ")+1:len(rule)]
                text = re.sub(first, second, text ,re.LOCALE|re.IGNORECASE)
            except:
                sys.stderr.write(u"Ошибка при разборе регулярного выражения: %s\n"%rule)
                continue
        elif rule.startswith("$exec "):
            rule = rule[6:len(rule)]
            try:
                first = "(%s)"%rule[0:rule.index(" ")]
                second = rule[rule.index(" ")+1:len(rule)]
                r = re.compile(first)
                for res in r.findall(text):
                    resIsString = res[0] == res[0][0] # страшный костыль
                    if resIsString:
                        print r.sub(second,res)
                        subprocess.Popen(r.sub(second,res),shell=True)
                    else:
                        print r.sub(second,res[0])
                        subprocess.Popen(r.sub(second,res[0]),shell=True)
            except:
                sys.stderr.write(u"Ошибка при разборе регулярного выражения: %s\n"%rule)
                continue
        else:
            if not -1==text.find(rule):
                return (False,"")
            pass
    return (True,text)

def wakabamarkToHtml(text,title):
  # TODO: ^W, ^H
  regList = [
    (r"&", r"&amp;"),
    (r"#", r"&#35;"),
    (r"\"", r"&quot;"),
    (r"%", r"&#37;"),
    (r"'", r"&#39;"),
    (r"\\", r"&#92;"),
    (r"/", r"&#47;"),
    (r"\+", r"&#43;"),
    (r"=", r"&#61;"),
    (r"<", r"&#60;"),
    (r">", r"&#62;")
    ]
  for rule in regList:
    text = re.sub(rule[0],rule[1],text)
  textList = text.split("\r\n")
  regList = [
    (r"_(_|\*)\*(.+?)\*\1_",r"<b><i>\2</b></i>"),                                           # bold+italic
    (r"(\*\*|__)(.+?)\1",r"<b>\2</b>"),                                                     # bold
    (r"([\*_])(.+?)\1",r"<i>\2</i>"),                                                       # italic
    (r"`(.+?)`",r"<font color='%s'>\1</font>"%codeColor),                                   # mono
    (r"&#37;&#37;(.+?)&#37;&#37;",r"<font color='%s'>\1</font>"%spoilerColor),              # spoiler
    (r"(&#62;&#62;((&#47;)?[a-z]+&#47;)?\d+)",r"<font color='%s'>\1</font>"%postColor),     # post
    (r"(https?:&#47;&#47;[^ \t\n\r\f\v<>]+)", "<a href=\"\\1\">\\1</a>")                       # url
#   (r"(\b\w+?\b)(\^H)*\^W(\^[WH])*",r"<s>\1</s>")    # ^W
    ]
  text = ""
  for textLine in textList:
    for rule in regList:
      if not textLine.startswith("    "):
        textLine = re.sub(rule[0],rule[1],textLine)
    if len(text):
      text += "\r\n"
    text += textLine
  multiLineRegList = [
    (r"(^|\r\n)&#37;&#37;\r\n(.*((\r\n.*)*))\r\n&#37;&#37;($|\r\n)",r"\1<font color='%s'>\2</font>\5"%spoilerColor),  # spoiler
    (r"(^|\r\n)``\r\n(.*(\r\n.*)*)\r\n``($|\r\n)",r"\1<font color='%s'>\2</font>\4"%codeColor),                       # mono
    (r"(^|\r\n)(&#62;.+?)(\r\n|$)",r"\1<font color='%s'>\2</font>\3"%quoteColor),                                     # quote
    (r"(\r\n){2,}",r"\r\n")
    ]
  for rule in multiLineRegList:
    text = re.sub(rule[0],rule[1],text,re.DOTALL|re.MULTILINE)
  text = u"Новое сообщение %s:<br/>%s"%(post['date'],text)
  title = "<a href=\"http://%s/%s/res/%s.xhtml\">%s</a>"%(host,board,thread,title)
  if options.debug: print text
  return text, title

# START

parser = optparse.OptionParser()
parser.add_option('-b','--board',dest="board",help=u"Доска", default=defaultBoard)
parser.add_option('-t','--thread',dest="thread",help=u"Номер треда", default=defaultThread)
parser.add_option('-i','--lastid',dest="lastId",help=u"Номер последнего сообщения (необязательно)", default="-1")
parser.add_option('-s','--site',dest="host",help=u"Адрес АИБ (дефолт - dobrochan.ru)", default="dobrochan.ru")
parser.add_option('-q','--quiet',action="store_true",dest="quiet",help=u"Не выводить сообщения в stdout",default=False)
parser.add_option('-u','--unrated',dest="unrated",action="store_true",help=u"Показывать иконки без рейтинга",default=False)
parser.add_option('-r','--rating',dest="rating",help=u"Максимальный разрешенный рейтинг иконок (дефолт - sfw) [sfw/r-15/r-18/r-18g]", default=defaultMaximumRating)
parser.add_option('-p','--period',dest="timeout",help=u"Период проверки новых сообщений", type='int', default=defaultTimeout)
parser.add_option('-n','--notifytime',dest="showtime",help=u"Время отображения уведомлений", type='int', default=defaultShowTime)
parser.add_option('--ht','--hidewotext',dest="hideWithoutText",action="store_true",help=u"Скрывать сообщения без текста",default=False)
parser.add_option('--hp','--hidewopic',dest="hideWithoutPic",action="store_true",help=u"Скрывать сообщения без картинок",default=False)
if defaultHtmlFormat:
  parser.add_option('--pt','--plaintext',dest="htmlFormat",action="store_false",help=u"Не использовать форматирование HTML",default=True)
else:
  parser.add_option('-f','--format',dest="htmlFormat",action="store_true",help=u"Использовать форматирование HTML",default=False)
parser.add_option('--cp','--postcolor',dest="postColor",help=u"Цвет ссылки на сообщение", default=defaultPostColor)
parser.add_option('--cq','--quotecolor',dest="quoteColor",help=u"Цвет цитаты", default=defaultQuoteColor)
parser.add_option('--cs','--spoilercolor',dest="spoilerColor",help=u"Цвет спойлера", default=defaultSpoilerColor)
parser.add_option('--cc','--codecolor',dest="codeColor",help=u"Цвет моноширинного текста", default=defaultCodeColor)
parser.add_option('-d','--debug',dest="debug",help=u"Вывод отладочной информации", action="store_true", default=False)
parser.add_option('--no-popup',dest="nopopup",help=u"Не выводить всплывающие уведомления (нужно для фильтрации треда через $exec)", action="store_true", default=False)
parser.add_option('--regexps',dest="regexps",help=u"Параметры фильтрации (подробности - в исходнике)", default=json.dumps(userRules))
options, args = parser.parse_args()

allowedRatings = ['sfw','r-15','r-18','r-18g']

hideWithoutText = options.hideWithoutText
hideWithoutPic = options.hideWithoutPic
htmlFormat = options.htmlFormat
showTime = options.showtime
postColor = options.postColor
quoteColor = options.quoteColor
spoilerColor = options.spoilerColor
codeColor = options.codeColor

try:
    userRules = json.loads(options.regexps)
except:
    sys.stderr.write(u"Ошибка при разборе параметра --regexps\n")
    sys.exit()
host = options.host
board = options.board
thread = options.thread
timeout = options.timeout
showUnrated = options.unrated
if options.rating in allowedRatings:
  allowedRatings = allowedRatings[0:allowedRatings.index(options.rating)+1]
else:
  allowedRatings = ['swf']
if showUnrated: allowedRatings.append('unrated')
if not options.quiet: print u"Разрешенный рейтинг изображений: %s"%allowedRatings

if not pynotify.init("%s notificator"%host):
  sys.stderr.write(u"Ошибка при инициализации модуля pynotify. Может быть он не установлен?")
  exit()

try:
  urllib.urlretrieve('http://%s/favicon.ico'%host,'/tmp/%s.ico'%host)
except:
  sys.stderr.write(u"Ошибка при получении favicon")

err = 1
while err:
  try:
    info = urllib.urlopen("http://%s/api/thread/info/%s/%s.js"%(host,board,thread))
    infoDump = info.read()
    infoObj = json.loads(infoDump)
    err = 0
  except:
    sys.stderr.write(u"Не могу получить данные... Повтор")
    time.sleep(timeout)
    err = 1
if not options.quiet: print u"В треде >>%s/%s \"%s\" найдено: сообщений - %s, файлов - %s. Последнее изменение произведено в %s"%(
  board,
  thread,
  infoObj['boards'][board]['threads'][0]['title'],
  infoObj['boards'][board]['threads'][0]['posts_count'],
  infoObj['boards'][board]['threads'][0]['files_count'],
  infoObj['boards'][board]['threads'][0]['last_modified']
)
if "-1" == options.lastId:
  err = 1
  while err:
    try:
      messages = urllib.urlopen("http://%s/%s/res/%s.js"%(host,board,thread))
      messDump = messages.read()
      messObj = json.loads(messDump)
      lastId = messObj['boards'][board]['threads'][0]['posts'].pop()['display_id']
      err = 0
    except:
      sys.stderr.write(u"Не могу получить данные... Повтор")
      time.sleep(timeout)
      err = 1
else:  
  lastId = options.lastId
if not options.quiet: print u"Last display ID = %s"%lastId
posts = []
while 1:
  try:
    messages = urllib.urlopen("http://%s/api/thread/new/%s/%s.js?last_post=%s"%(host,board,thread,lastId))
    messDump = messages.read()
    messObj = json.loads(messDump)
  except:
    sys.stderr.write(u"Ошибка подключения.. Повтор")
    time.sleep(timeout)
    continue
  if 'posts' in messObj['boards'][board]['threads'][0]:
    posts = messObj['boards'][board]['threads'][0]['posts']
  else:
    posts = []
  for post in posts:
    lastId = post['display_id']
#    if (hideSage and post['sage']) or (hideWithoutText and 0==len(post['message'])):
    if hideWithoutText and 0==len(post['message']):
      continue
    if not options.quiet: print "%s : %s"%(post['display_id'],post['message'])
    ok, messageText = userFilter(post)
    if (not ok) or options.nopopup:
        continue
    mesFiles = post['files']
    mesThumbData = 0
    if mesFiles and ('thumb' in mesFiles[0].keys()) and (mesFiles[0]['rating'] in allowedRatings):
      try:
        mesThumb = urllib.urlopen("http://%s/%s"%(host,mesFiles[0]['thumb']))
        mesThumbData = mesThumb.read()
      except:
        mesThumbData = 0
    if hideWithoutPic and (0 == mesThumbData):
        continue
    if htmlFormat:
      messageText, messageTitle = wakabamarkToHtml(messageText,infoObj['boards'][board]['threads'][0]['title'])
    else:
      messageText = u"Новое сообщение %s:\n%s"%(post['date'],messageText)
      messageTitle = infoObj['boards'][board]['threads'][0]['title']
    filesCount = len(post['files'])
    if filesCount > 1:
      messageText += '\n(%s файла)'%filesCount;
    n = pynotify.Notification(
      messageTitle,
      messageText,
      '/tmp/%s.ico'%host)
    n.set_urgency(pynotify.URGENCY_NORMAL)
    if mesThumbData:
      loader = gtk.gdk.PixbufLoader()
      loader.write(mesThumbData)
      loader.close()
      pixbuf = loader.get_pixbuf()
      n.set_icon_from_pixbuf(pixbuf)
    n.set_timeout(showTime)
    n.show()
  time.sleep(timeout)